#include <cstdio>
#include <algorithm>
#include <cstdlib>

#define MAXN 1000000

using namespace std;

int N;
int cards[MAXN];
int lis[MAXN], lds[MAXN];
int peak=0;

void input(void)
{
	int index;
	
	scanf("%d", &N);
	for(index=0; index<N; ++index)
	{
		scanf("%d", &cards[index]);
		if(cards[index]>cards[peak])
		{
			peak=index;
		}
	}
}

void LIS(int *res)
{
	int index, len, pos;
	static unsigned last[MAXN];
	
	memset(last, -1, sizeof last);
	last[0]=cards[0];
	len=1;
	res[0]=1;
	
	for(index=1; index<N; ++index)
	{
		pos=upper_bound(last, last+len, cards[index])-last;
		last[pos]=cards[index];
		if(pos==len)
		{
			++len;
		}
		res[index]=len;
	}	
}

int calc(void)
{
	int best, curr;
	int index;
	
	best=N-lds[0];//+(peak!=0);
	//printf("0 %d\n", best);
	curr=N-lis[N-1];//+(peak!=N-1);
	if(curr<best)
	{
		best=curr;
		//printf("%d %d\n", N-1, best);
	}
	
	for(index=1; index<N; ++index)
	{
		curr=N-lis[index]-lds[index+1];//+(peak!=index);
		if(curr<best)
		{
			best=curr;
			//printf("%d %d\n", index, best);
		}
	}
	
	return best;
}

int main(void)
{
	input();
	
	LIS(lis);
	reverse(cards, cards+N);
	LIS(lds);
	reverse(cards, cards+N);
	reverse(lds, lds+N);
	
	printf("%d\n", calc());
	
	//system("pause");
	return 0;
}
